﻿using MySqlConnector;

namespace MySQL_Manager;

public class Database
{
    private string conection;
    
    public Database(string ConnectionString)
    {
        conection = ConnectionString;
    }

    public void ExecuteNonQuery(string command)
    {
        try
        {
            MySqlConnection conn = new MySqlConnection(conection);
            conn.Open();
            MySqlCommand cmd = new MySqlCommand(command, conn);
            _ = cmd.ExecuteNonQuery();
            conn.Close();
        }
        catch (Exception e)
        {
            Console.WriteLine(e);
            throw;
        }
    }
    
    public TReturn Read<TReturn>(string command)
    {
        try
        {
            MySqlConnection conn = new MySqlConnection(conection);
            conn.Open();
            MySqlCommand cmd = new MySqlCommand(command, conn);
            object? temp = cmd.ExecuteScalar();
            if (temp is DBNull || temp is null)
            {
                return default!;
            }
            if (typeof(TReturn).IsEnum) return (TReturn?)Enum.Parse(typeof(TReturn), temp.ToString()!)!;
            if (typeof(TReturn).IsNullableEnum()) return (TReturn?)Enum.Parse(Nullable.GetUnderlyingType(typeof(TReturn))!, temp.ToString()!)!;
            return (TReturn?)temp!;
        }
        catch (Exception e)
        {
            Console.WriteLine(e);
            throw;
        }
    }
}